<?php
/**
 * Created by PhpStorm.
 * User: matheusneves
 * Date: 13/01/2016
 * Time: 09:53
 */

namespace Teknisa\MAN\Services;

use Teknisa\MAN\Utilities;
use Teknisa\MAN\Factories;

class GetFiliais{
    const INSERE_FILIAL = 1;
    const FILIAL_INATIVA = 2;
    const FILIAL_ATIVA = 3;
    const INSERE_LOJA = 4;
    const LOJA_INATIVA = 5;
    const LOJA_ATIVA = 6;

    protected $filiaisRepository;
    public function __construct(Factories\GetFiliaisRepository $filiaisRepository, \Doctrine\ORM\EntityManager $entityManager){
        $this->filiaisRepository = $filiaisRepository;
        $this->entityManager = $entityManager;
    }

    public function getNextId(){
        $idRow = $this->filiaisRepository->getMaxId();
        $id = $idRow[0]['MAX_ID'];
        return !is_null($id) ? ++$id : 1;
    }

    public function getFiliaisByNrorg($param){ // Filial, loja, pdv
		$caixas = $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_TREE_PARAMSPDV_BY_NRORG, $param);
		return $caixas;	
    }

    public function getFiliaisLojasByNrorg($param){ /// Filial e loja
    	$lojas = $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_FILIAIS_LOJAS, $param);
		return $lojas;	
    }

    public function getFiliais($param){
    	$filiais = $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_FILIAIS_BYNRORG, $param);
    	return $filiais;	
    }

    public function getFilialPorLoja($nrseqturno, $cdfilial, $nrorg) {
        $params = array('NRSEQTURNO' => $nrseqturno,
                        'CDFILIAL' => $cdfilial, 
                        'NRORG' => $nrorg);
        $rows = $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_RELTURNO_FILIAIS_LOJA, $params);
        if(empty($rows)){
            return 1;
        } else {
            return $rows;
        }
    }

    public function validaFilial($nrseqturno, $cdfilial, $nrorg){
        $stmt = $this->entityManager->getConnection()->prepare(Utilities\Query::GET_IDATIVO_VND_RELACIONAMENTOTURNO);
        $stmt->execute(array('NRSEQTURNO' => $nrseqturno,
                             'CDFILIAL' => $cdfilial,
                             'NRORG' => $nrorg));
        $resp = $stmt->fetchAll();
        $id = null;
        if(empty($resp)){
            $retorno = self::INSERE_FILIAL;
        } else{
            $retorno = $resp[0]['IDATIVO'] == 'S' ? self::FILIAL_ATIVA : self::FILIAL_INATIVA;
            $id = $resp[0]['NRRELACIONAMENTO'];
        }
        return array('valida'=>$retorno,
                     'NRRELACIONAMENTO' => $id);
    }

    public function validaLoja($nrseqturno, $cdfilial, $cdloja, $nrorg){
        $stmt = $this->entityManager->getConnection()->prepare(Utilities\Query::GET_VND_RELACIONAMENTOTURNO_VALIDALOJA);
        $stmt->execute(array('NRSEQTURNO' => $nrseqturno,
                             'CDFILIAL' => $cdfilial,
                             'CDLOJA' => $cdloja,
                             'NRORG' => $nrorg));
        $resp = $stmt->fetchAll();
        $id = null;
        if(empty($resp)) {
            $retorno = self::INSERE_LOJA;
        } else {
            $retorno = $resp[0]['IDATIVO'] == 'S' ? self::LOJA_ATIVA : self::LOJA_INATIVA;
            $id = $resp[0]['NRRELACIONAMENTO'];
        }
        return array('valida'=>$retorno,
                     'NRRELACIONAMENTO' => $id);
    }
}