<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;

class RelExtratoConsumidorService {

	public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }

    public function findSintetico($CDFILIAL, $CDTIPOCONS, $DTLANCINI, $DTLANCFIN, $CDLOJA, $CDCONSUMIDOR, $NOMEINI, $NOMEFIM, $TCDCLIENTE, $TCDLOJA, $TCDCONSUMIDOR, $TCDTIPOCONS, $CDCLIENTE, $TIPOSALDO) {
        $params = array(
            ':CDFILIAL'         => $CDFILIAL,
         	':CDTIPOCONS'       => $CDTIPOCONS,
         	':DTLANCINI'        => $DTLANCINI,
         	':DTLANCFIN'        => $DTLANCFIN,
         	':CDLOJA'           => $CDLOJA,
         	':CDCONSUMIDOR'     => $CDCONSUMIDOR,
         	':NOMEINI'          => $NOMEINI,
         	':NOMEFIM'          => $NOMEFIM,
         	':TCDCLIENTE'       => $TCDCLIENTE,
         	':TCDCONSUMIDOR'    => $TCDCONSUMIDOR,
         	':TCDLOJA'          => $TCDLOJA,
         	':TCDTIPOCONS'      => $TCDTIPOCONS,
         	':CDCLIENTE'        => $CDCLIENTE
 		);
        $result = $this->entityManager->getConnection()->fetchAll(self::GET_EXTRATO_SINTETICO, $params);
 		
 		if ($TIPOSALDO == 'C'){
 		    foreach($result as $chTR => $valTR){
     		    $result [$chTR]['CONSUMIDOR'] = $result [$chTR]['CDCONSUMIDOR']." - ".$result [$chTR]['NMCONSUMIDOR'];
     		    $result [$chTR]['SALDOINI'] = $result [$chTR]['VRSALDOINIPESCONS'];
     		    $result [$chTR]['CUSTO'] = $result [$chTR]['CDCCUSCLIE']." - ".$result [$chTR]['NMCCUSCLIE'];
     		    $result [$chTR]['VRCREDAJUS'] = $result [$chTR]['VRMOVPESOUTR'];
     		    $result [$chTR]['VRSALDEMP'] = $result [$chTR]['VRSALDPECONS'];
        	}
 		} else {
 		    foreach($result as $chTR => $valTR){
     		    $result [$chTR]['CONSUMIDOR'] = $result [$chTR]['CDCONSUMIDOR']." - ".$result [$chTR]['NMCONSUMIDOR'];
     		    $result [$chTR]['SALDOINI'] = $result [$chTR]['VRSALDOINIEMP'];
     		    $result [$chTR]['CUSTO'] = $result [$chTR]['CDCCUSCLIE']." - ".$result [$chTR]['NMCCUSCLIE'];
     		    $result [$chTR]['VRCREDAJUS'] = $result [$chTR]['VRMOVCLIOUTR'];
     		    $result [$chTR]['VRSALDEMP'] = $result [$chTR]['VRSALDOCONS'];
        	}
 		}
 		
 		return $result;
    }
    
    public function findAnalitico($CDFILIAL, $CDTIPOCONS, $DTLANCINI, $DTLANCFIN, $CDLOJA, $CDCONSUMIDOR, $NOMEINI, $NOMEFIM, $TCDCLIENTE, $TCDLOJA, $TCDCONSUMIDOR, $TCDTIPOCONS, $CDCLIENTE, $TIPOSALDO) {
        $params = array(
            ':CDFILIAL'         => $CDFILIAL,
         	':CDTIPOCONS'       => $CDTIPOCONS,
         	':DTLANCINI'        => $DTLANCINI,
         	':DTLANCFIN'        => $DTLANCFIN,
         	':CDLOJA'           => $CDLOJA,
         	':CDCONSUMIDOR'     => $CDCONSUMIDOR,
         	':NOMEINI'          => $NOMEINI,
         	':NOMEFIM'          => $NOMEFIM,
         	':TCDCLIENTE'       => $TCDCLIENTE,
         	':TCDCONSUMIDOR'    => $TCDCONSUMIDOR,
         	':TCDLOJA'          => $TCDLOJA,
         	':TCDTIPOCONS'      => $TCDTIPOCONS,
         	':CDCLIENTE'        => $CDCLIENTE
 		);
 		$result = $this->entityManager->getConnection()->fetchAll(self::GET_EXTRATO_ANALITICO, $params);
 		
 		if ($TIPOSALDO == 'C'){
 		    foreach($result as $chTR => $valTR){
     		    $result [$chTR]['CONSUMIDOR'] = $result [$chTR]['CDCONSUMIDOR']." - ".$result [$chTR]['NMCONSUMIDOR']." | Saldo Inicial: ".$result [$chTR]['VRSALDOINIPESCONS']." | Saldo Final: ".$result [$chTR]['VRSALDPECONS'];
     		    $result [$chTR]['CUSTO'] = $result [$chTR]['CDCCUSCLIE']." - ".$result [$chTR]['NMCCUSCLIE'];
     		    $result [$chTR]['VRCONS'] = $result [$chTR]['VRMOVPESCONSUMO'];
     		    $result [$chTR]['VRCREDAJUS'] = $result [$chTR]['VRMOVPESOUTR'];
     		    $result [$chTR]['VRSALDEMP'] = $result [$chTR]['VRSALDPECONS'];
        	}
 		} else {
 		    foreach($result as $chTR => $valTR){
     		    $result [$chTR]['CONSUMIDOR'] = $result [$chTR]['CDCONSUMIDOR']." - ".$result [$chTR]['NMCONSUMIDOR']." | Saldo Inicial: ".$result [$chTR]['VRSALDOINIEMP']." | Saldo Final: ".$result [$chTR]['VRSALDOCONS'];
     		    $result [$chTR]['CUSTO'] = $result [$chTR]['CDCCUSCLIE']." - ".$result [$chTR]['NMCCUSCLIE'];
     		    $result [$chTR]['VRCONS'] = $result [$chTR]['VRMOVCLICONSUMO'];
     		    $result [$chTR]['VRCREDAJUS'] = $result [$chTR]['VRMOVCLIOUTR'];
     		    $result [$chTR]['VRSALDEMP'] = $result [$chTR]['VRSALDOCONS'];
        	}
 		}
 		
 		return $result;
    }
    
    public function findConsumidor($CDFILIAL, $CDCLIENTE, $TCDCLIENTE, $NOMEINI, $NOMEFIM,  $CDTIPOCONS, $TCDTIPOCONS) {
        $params = array(
            ':CDFILIAL'         => $CDFILIAL,
         	':CDTIPOCONS'       => $CDTIPOCONS,
         	':NOMEINI'          => $NOMEINI,
         	':NOMEFIM'          => $NOMEFIM,
         	':TCDCLIENTE'       => $TCDCLIENTE,
         	':TCDTIPOCONS'      => $TCDTIPOCONS,
         	':CDCLIENTE'        => $CDCLIENTE
 		);
 		
 		return $this->entityManager->getConnection()->fetchAll(self::GET_CONSUMIDOR, $params);;
    }
    
    const GET_CONSUMIDOR = "
    SELECT DISTINCT 'N' IDMARCADO,
       CO.CDCLIENTE||CO.CDCONSUMIDOR AS CLICONS, CO.CDCLIENTE, CO.CDCONSUMIDOR, CO.NMCONSUMIDOR, CO.CDTIPOCONS
    FROM
       CONSUMIDOR CO, CLIENTE CL, CLIENFILIAL CF
    WHERE
       ((INSTR(:CDCLIENTE , CO.CDCLIENTE ) > 0) OR (:TCDCLIENTE  = 'T') OR (UPPER(CL.NMRAZSOCCLIE) BETWEEN UPPER(:NOMEINI) AND UPPER(:NOMEFIM))) AND
       ((INSTR(:CDTIPOCONS, CO.CDTIPOCONS) > 0) OR (:TCDTIPOCONS = 'T')) AND
       (CO.CDCLIENTE = CL.CDCLIENTE) AND
       (CF.CDCLIENTE = CO.CDCLIENTE) AND
       (CF.CDFILIAL  = :CDFILIAL )
    ORDER BY 2, 3
    ";
    
    const GET_EXTRATO_SINTETICO = "
    SELECT DISTINCT A.CDCLIENTE   , A.NRINSJURCLIE,   A.IDTPIJURCLIE, A.NMFANTCLIE, A.NMCCUSCLIE,
       A.CDCONSUMIDOR, A.NMCONSUMIDOR,   A.CDTIPOCONS  , A.CDCCUSCLIE, A.VRPESUBCONS,
       A.MAXDTMOVCLI , A.VRMOVCLICONSUMO,A.VRMOVCLIOUTR, A.VRCREDITOS, A.VRAJUSTEDEBITOS,A.VRMOVPESCONSUMO,
       A.VRMOVPESOUTR, A.VRCREDITOSPES,A.VRAJUSTEDEBPES, M.VRSALDPECONS - VRMOVPESCONSUMO AS VRSALDOINIPESCONS,
       M.VRSALDOCONS , M.VRSALDPECONS, A.MINDTMOVCLI, M.VRSALDOCONS - VRMOVCLICONSUMO AS VRSALDOINIEMP
    FROM
       MOVICLIE M,
       (SELECT DISTINCT M.CDCLIENTE, CL.NRINSJURCLIE, CL.IDTPIJURCLIE, CL.NMFANTCLIE,U.NMCCUSCLIE,
               M.CDCONSUMIDOR, C.NMCONSUMIDOR, C.CDTIPOCONS, C.CDCCUSCLIE, C.VRPESUBCONS,
               MAX(M.DTMOVCLI) AS MAXDTMOVCLI, MIN(M.DTMOVCLI) AS MINDTMOVCLI,
               SUM(DECODE(M.NRSEQVENDA,NULL,0,DECODE(M.IDTIPMOCVLI,'D',(-1)*M.VRMOVCLI))) AS VRMOVCLICONSUMO,
               SUM(DECODE(M.IDTIPMOCVLI,'C',M.VRMOVCLI,DECODE(M.IDTIPMOCVLI,'A',(-1)*M.VRMOVCLI,DECODE(M.IDTIPMOCVLI||NVL(M.NRSEQVENDA,'D'),'DD',(-1)*M.VRMOVCLI,0)))) AS VRMOVCLIOUTR,
               SUM(DECODE(M.IDTIPMOCVLI,'C',M.VRMOVCLI,0)) AS VRCREDITOS,
               SUM(DECODE(M.IDTIPMOCVLI,'A',(-1)*M.VRMOVCLI,DECODE(M.IDTIPMOCVLI||NVL(M.NRSEQVENDA,'D'),'DD',(-1)*M.VRMOVCLI,0))) AS VRAJUSTEDEBITOS,
               SUM(DECODE(M.NRSEQVENDA,NULL,0,DECODE(M.IDTIPMOCVLI,'D',(-1)*M.VRMOVPESCONS))) AS VRMOVPESCONSUMO,
               SUM(DECODE(M.IDTIPMOCVLI,'C',M.VRMOVPESCONS,DECODE(M.IDTIPMOCVLI,'A',(-1)*M.VRMOVPESCONS,DECODE(M.IDTIPMOCVLI||NVL(M.NRSEQVENDA,'D'),'DD',(-1)*M.VRMOVPESCONS,0)))) AS VRMOVPESOUTR,
               SUM(DECODE(M.IDTIPMOCVLI,'C',M.VRMOVPESCONS)) AS VRCREDITOSPES,
               SUM(DECODE(M.IDTIPMOCVLI,'A',(-1)*M.VRMOVPESCONS,DECODE(M.IDTIPMOCVLI||NVL(M.NRSEQVENDA,'D'),'DD',(-1)*M.VRMOVPESCONS,0))) AS VRAJUSTEDEBPES
        FROM MOVICLIE M, CLIENTE CL, 
              
              (SELECT CDCLIENTE, CDCONSUMIDOR, CDCCUSCLIE, CDTIPOCONS, NMCONSUMIDOR, VRPESUBCONS FROM CONSUMIDOR
               WHERE
                ((INSTR( :CDTIPOCONS  ,CDTIPOCONS)                 <> 0) OR ( :TCDTIPOCONS   = 'T'))) C,
    
              (SELECT CDCLIENTE, CDCCUSCLIE, NMCCUSCLIE FROM CCUSCLIE ) U,
    
              (SELECT CDFILIAL, CDLOJA FROM LOJA
               WHERE
                ((INSTR( :CDLOJA, CDFILIAL||CDLOJA) <> 0) OR ( :TCDLOJA = 'T'))) LJ
    
    
        WHERE (M.CDCLIENTE    = CL.CDCLIENTE  ) AND
              (M.CDFILIAL     = LJ.CDFILIAL(+)) AND
              (C.CDCLIENTE    = M.CDCLIENTE   ) AND
              (C.CDCONSUMIDOR = M.CDCONSUMIDOR) AND
              (M.DTMOVIMCLIE BETWEEN  :DTLANCINI AND  :DTLANCFIN) AND
              ((INSTR( :CDCLIENTE   ,M.CDCLIENTE) > 0) OR ( :TCDCLIENTE = 'T')  OR (CL.NMRAZSOCCLIE BETWEEN  :NOMEINI AND  :NOMEFIM)) AND
              ((INSTR( :CDCONSUMIDOR, M.CDCONSUMIDOR)  <> 0) OR ( :TCDCONSUMIDOR = 'T')) AND
              (C.CDCLIENTE   = U.CDCLIENTE ) AND
              (C.CDCCUSCLIE  = U.CDCCUSCLIE)          
    
        GROUP BY M.CDCLIENTE, CL.NRINSJURCLIE, CL.IDTPIJURCLIE, CL.NMFANTCLIE,U.NMCCUSCLIE,U.CDCCUSCLIE,
                 M.CDCONSUMIDOR, C.NMCONSUMIDOR, C.CDTIPOCONS, C.CDCCUSCLIE, C.VRPESUBCONS) A
    WHERE M.CDCLIENTE    = A.CDCLIENTE
      AND M.CDCONSUMIDOR = A.CDCONSUMIDOR
      AND M.DTMOVCLI     = A.MAXDTMOVCLI
    ORDER BY
       A.CDCLIENTE, A.CDCCUSCLIE, A.CDCONSUMIDOR
    ";

    const GET_EXTRATO_ANALITICO = "
    SELECT A.*, M.VRSALDOCONS, M.VRSALDPECONS,
       CDCCUSCLIE, ABS (NVL((VRMOVCLICONSUMO*(1-((NVL(VRPESUBCONS, 0))/100))), 0)) AS VRDESCFOL,
       M.VRSALDPECONS - VRMOVPESCONSUMO AS VRSALDOINIPESCONS, M.VRSALDOCONS - VRMOVCLICONSUMO AS VRSALDOINIEMP
    FROM
       MOVICLIE M,
       (SELECT M.CDCLIENTE, CL.NRINSJURCLIE, CL.IDTPIJURCLIE, CL.NMFANTCLIE,C.CDCCUSCLIE, D.NMCCUSCLIE,
               M.CDCONSUMIDOR, C.NMCONSUMIDOR, TRUNC(M.DTMOVCLI) AS DTMOVCLI, C.VRPESUBCONS, 
               MAX(M.DTMOVCLI) AS MAXDTMOVCLI,
               SUM(NVL((DECODE(M.NRSEQVENDA,NULL,0,DECODE(M.IDTIPMOCVLI,'D',(-1)*M.VRMOVCLI))), 0)) AS VRMOVCLICONSUMO,
               SUM(DECODE(M.IDTIPMOCVLI,'C',M.VRMOVCLI,DECODE(M.IDTIPMOCVLI,'A',(-1)*M.VRMOVCLI,DECODE(M.IDTIPMOCVLI||NVL(M.NRSEQVENDA,'D'),'DD',(-1)*M.VRMOVCLI,0)))) AS VRMOVCLIOUTR,
               SUM(DECODE(M.IDTIPMOCVLI,'C',M.VRMOVCLI,0)) AS VRCREDITOS,
               SUM(DECODE(M.IDTIPMOCVLI,'A',(-1)*M.VRMOVCLI,DECODE(M.IDTIPMOCVLI||NVL(M.NRSEQVENDA,'D'),'DD',(-1)*M.VRMOVCLI,0))) AS VRAJUSTEDEBITOS,
               SUM(DECODE(M.NRSEQVENDA,NULL,0,DECODE(M.IDTIPMOCVLI,'D',(-1)*M.VRMOVPESCONS))) AS VRMOVPESCONSUMO,
               SUM(DECODE(M.IDTIPMOCVLI,'C',M.VRMOVPESCONS,DECODE(M.IDTIPMOCVLI,'A',(-1)*M.VRMOVPESCONS,DECODE(M.IDTIPMOCVLI||NVL(M.NRSEQVENDA,'D'),'DD',(-1)*M.VRMOVPESCONS,0)))) AS VRMOVPESOUTR,
               SUM(DECODE(M.IDTIPMOCVLI,'C',M.VRMOVPESCONS)) AS VRCREDITOSPES,
               SUM(DECODE(M.IDTIPMOCVLI,'A',(-1)*M.VRMOVPESCONS,DECODE(M.IDTIPMOCVLI||NVL(M.NRSEQVENDA,'D'),'DD',(-1)*M.VRMOVPESCONS,0))) AS VRAJUSTEDEBPES
        FROM CCUSCLIE D, CLIENFILIAL F, CLIENTE CL, CONSUMIDOR C, MOVICLIE M , CAIXA CX
        WHERE (F.CDFILIAL     =  :CDFILIAL)    AND
              (M.CDFILIAL   = CX.CDFILIAL (+) ) AND 
              (M.CDCAIXA    = CX.CDCAIXA  (+)) AND 
              ((INSTR( :CDCLIENTE, M.CDCLIENTE) > 0) OR ( :TCDCLIENTE = 'T')  OR (CL.NMRAZSOCCLIE BETWEEN  :NOMEINI AND  :NOMEFIM)) AND
              ((INSTR( :CDCONSUMIDOR, M.CDCONSUMIDOR) <> 0) OR ( :TCDCONSUMIDOR = 'T')) AND
              ((INSTR( :CDLOJA, M.CDFILIAL||CX.CDLOJA) <> 0) OR ( :TCDLOJA = 'T')) AND
              ((INSTR( :CDTIPOCONS,   C.CDTIPOCONS  ) <> 0) OR ( :TCDTIPOCONS = 'T'  )) AND
              (M.DTMOVIMCLIE BETWEEN  :DTLANCINI AND :DTLANCFIN) AND
              (M.CDCLIENTE    = F.CDCLIENTE)    AND
              (M.CDCLIENTE    = CL.CDCLIENTE)   AND
              (M.CDCLIENTE    = D.CDCLIENTE)    AND
              (C.CDCCUSCLIE   = D.CDCCUSCLIE)   AND
              (C.CDCLIENTE    = M.CDCLIENTE) AND
              (C.CDCONSUMIDOR = M.CDCONSUMIDOR)          
        GROUP BY M.CDCLIENTE, CL.NRINSJURCLIE, CL.IDTPIJURCLIE, CL.NMFANTCLIE,C.CDCCUSCLIE,D.NMCCUSCLIE,
                 M.CDCONSUMIDOR, C.NMCONSUMIDOR, TRUNC(M.DTMOVCLI), C.VRPESUBCONS) A
    WHERE M.CDCLIENTE    = A.CDCLIENTE
      AND M.CDCONSUMIDOR = A.CDCONSUMIDOR
      AND M.DTMOVCLI = A.MAXDTMOVCLI
    ORDER BY M.CDCLIENTE, A.CDCCUSCLIE, M.CDCONSUMIDOR, A.DTMOVCLI
    
    ";
}